#!/bin/sh
#
# Script which does some basic tests to ensure we haven't regressed.
# Probably a good idea to run this before doing any checkins.
# In the future this can become more fancy, but it's OK for now.

LUSTRE=${LUSTRE:-`dirname $0`/..}
SRCDIR="`dirname $0`"
export PATH=/sbin:/usr/sbin:$SRCDIR:$SRCDIR/../utils:$PATH

export NAME=${NAME:-local}

. $LUSTRE/tests/test-framework.sh
init_test_env $@
. ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}

RUNTESTS_SRC=${RUNTESTS_SRC:-"/etc /bin"}
[ "$COUNT" ] || COUNT=1000
[ "$SLOW" = "no" ] && COUNT=100

[ "$MCREATE" ] || MCREATE=mcreate

[ "$MKDIRMANY" ] || MKDIRMANY="createmany -d"

check_and_setup_lustre

OSCTMP=`echo $MOUNT | tr "/" "."`
USED=`df | awk "/$OSCTMP/ { print \\$3 }" | tail -n 1`
USED=`expr $USED + 16`	# Some space for the status file

# let's start slowly here...
START=`date +%s`
log "touching $MOUNT at `date`"
touch $MOUNT || error "can't touch $MOUNT" 2
HOSTS=$MOUNT/hosts.$$
TRUNCSIZE=123

if [ $COUNT -gt 10 -o $COUNT -eq 0 ]; then
	# this will cause the following cp to trigger bug #620096
	log "create an empty file $HOSTS"
	mcreate $HOSTS
	log "copying /etc/hosts to $HOSTS"
	cp /etc/hosts $HOSTS || error "can't cp /etc/hosts to $HOSTS" 3
	log "comparing /etc/hosts and $HOSTS"
	diff -u /etc/hosts $HOSTS || error "$HOSTS different" 4
	log "renaming $HOSTS to $HOSTS.ren"
	mv $HOSTS $HOSTS.ren || error "can't rename $HOSTS to $HOSTS.ren" 5
	log "copying /etc/hosts to $HOSTS again"
	cp /etc/hosts $HOSTS || error "can't cp /etc/hosts to $HOSTS again" 6
	log "truncating $HOSTS"
	> $HOSTS || error "can't truncate $HOSTS" 8
	log "removing $HOSTS"
	rm $HOSTS || error "can't remove $HOSTS" 9
	cp /etc/hosts $HOSTS.2 || error "can't cp /etc/hosts to $HOSTS.2" 7
	log "truncating $HOSTS.2 to $TRUNCSIZE bytes"
	truncate $HOSTS.2 $TRUNCSIZE
fi

DST=$MOUNT/runtest.$$
# let's start slowly here...
log "creating $DST"
mkdir $DST || error "can't mkdir $DST" 10

# ok, that hopefully worked, so let's do a little more, with files that
# haven't changed in the last day (hopefully they don't change during test)
FILES=$TMP/runtests.files
# use "NUL" instead of newline as filename terminator, bug 19702 
find $RUNTESTS_SRC -type f -mtime +1 | head -n $COUNT | tr '\n' '\0' > $FILES
[ -s "$FILES" ] || error "$RUNTESTS_SRC contains only files modifed less than 2 days ago"

log "copying files from $RUNTESTS_SRC to $DST$RUNTESTS_SRC at `date`"
tar cf - --null --files-from $FILES | tar xvf - -C $DST > /dev/null || error "copying $RUNTESTS_SRC" 11

log "comparing newly copied files at `date`"

cat $FILES | tr "\0" "\n" | ( rc=0; while read f; do
	[ $V ] && log "verifying $DST/$f"
	diff -q "$f" "$DST/$f" || rc=11
done
[ "$rc" = 0 ] || error_exit "old and new files are different: rc=$rc" ) 

log "finished at `date` ($(($(date +%s) - START)))"

stopall || exit 19
setupall || exit 20

log "comparing previously copied files"
cat $FILES | tr "\0" "\n" | ( rc=0; while read f; do
        [ $V ] && log "verifying $DST/$f"
        diff -q "$f" "$DST/$f" || rc=22
done
[ "$rc" = 0 ] || error_exit "old and new files are different: rc=$rc" )

stopall || exit 21
setupall || exit 22

log "removing $DST"
rm -r $V $DST || error "can't remove $DST" 37

if [ $COUNT -gt 10 -o $COUNT -eq 0 ]; then
	log "renaming $HOSTS.ren to $HOSTS"
	mv $HOSTS.ren $HOSTS || error "can't rename $HOSTS.ren to $HOSTS" 32
	log "truncating $HOSTS"
	> $HOSTS || error "can't truncate $HOSTS" 34
	log "removing $HOSTS"
	rm $HOSTS || error "can't remove $HOSTS again" 36
	log "verifying $HOSTS.2 is $TRUNCSIZE bytes"
	checkstat -s $TRUNCSIZE $HOSTS.2 || \
		error "$HOSTS.2 isn't $TRUNCSIZE bytes" 37
	rm $HOSTS.2 || error "can't remove $HOSTS.2" 38
fi

# mkdirmany test (bug 589)
log "running $MKDIRMANY $MOUNT/base$$ 100"
$MKDIRMANY $MOUNT/base$$ 100 || error "mkdirmany failed"
log "removing mkdirmany directories"
rmdir $MOUNT/base$$* || error "mkdirmany cleanup failed"

log "done"

NOWUSED=`df | awk "/$OSCTMP/ { print \\$3 }" | tail -n 1`
if [ `expr $NOWUSED - $USED` -gt 1024 ]; then
	echo "Space not all freed: now ${NOWUSED}kB, was ${USED}kB." 1>&2
fi

rm -f $FILES
check_and_cleanup_lustre
